#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        long n;
        cin >> n;
        long res = 0;
        vector <int> v(2*n+1,0);
        vector <int> a(n),b(n),c(n);
        for (int j = 0; j < n; j++) {
            cin >> a[j] >> b[j] >> c[j];
            v[a[j]]+=c[j];
            v[b[j]]+=c[j];
        }
        int maxn = max_element(v.begin(), v.end()) - v.begin();
        for (int j = 0; j < n; j++) {
            if (a[j] == maxn || b[j] == maxn)
            res+=c[j];
        }
        cout << res << endl;
    }
}
